routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('/', 'Website\WebsiteController@index')->name('home');
Route::get('/login', 'Auth\AuthAdminController@index')->name('admin-mitsubishi');
Route::post('/auth', 'Auth\AuthAdminController@dologin')->name('dologin');
Route::get('/logout', 'Auth\AuthAdminController@logout')->name('logout');


Route::group(['as' => 'angpao.', 'prefix' => '/angpao'], function () {
  Route::get('/form-input', 'Website\WebsiteController@formInput')->name('forminput');
  Route::post('/doverifynopol', 'Website\WebsiteController@doVerifyNoPol')->name('doverifynopol');
  Route::get('/anpaotree', 'Website\WebsiteController@angpaoTree')->name('angpaotree');
  Route::post('/doinputform', 'Website\WebsiteController@doInputForm')->name('doinputform');
  Route::post('/dolottery', 'Website\WebsiteController@doLottery')->name('dolottery');
  Route::get('/voucher', 'Website\WebsiteController@voucher')->name('voucher');
  Route::get('/logout', 'Website\WebsiteController@logout')->name('logout');

});

Route::group(['as' => 'superadmin.', 'prefix' => '/superadmin','middleware' => ['role:Super Admin']], function () {
    Route::get('/setting', 'SuperAdmin\DashboardController@setting')->name('setting');
    Route::post('/settingwebsite', 'SuperAdmin\DashboardController@settingWebsite')->name('settingwebsite');
    Route::get('/', 'SuperAdmin\DashboardController@index')->name('index');

    Route::group(['as' => 'dealer.', 'prefix' => '/dealer'], function () {
        Route::get('/', 'SuperAdmin\DealerController@index')->name('index');
        Route::post('/show/{id}', 'SuperAdmin\DealerController@show')->name('show');
        Route::post('/created', 'SuperAdmin\DealerController@store')->name('store');
        Route::post('/{id}/update', 'SuperAdmin\DealerController@update')->name('update');
        Route::post('/imports', 'SuperAdmin\DealerController@dealerImport')->name('dealerimport');
    });

    Route::group(['as' => 'angpao.', 'prefix' => '/angpao'], function () {
      Route::get('/', 'SuperAdmin\AngpaoController@index')->name('index');
      Route::post('/add-qty/{id}', 'SuperAdmin\AngpaoController@addQty')->name('addqty');
    });

    Route::get('/{dealer}/{start}/{end}/export', 'SuperAdmin\DashboardController@export')->name('customer.export');
});

Route::group(['as' => 'dealer.', 'prefix' => '/dealer','middleware' => ['role:Dealer']], function () {
    Route::get('/', 'Dealer\DealerController@index')->name('index');
    Route::get('/add-customer', 'Dealer\DealerController@AddCustomerIndex')->name('addcustomer');
    Route::get('/{id}/print', 'Dealer\DealerController@print')->name('print');
    Route::get('/search-customer', 'Dealer\DealerController@SearchCustomerIndex')->name('searchcustomer');
    Route::get('/list-customer', 'Dealer\DealerController@ListCustomerIndex')->name('listcustomer');
    Route::post('/{id}/show', 'Dealer\DealerController@show')->name('show');
    Route::post('/createcustomer', 'Dealer\DealerController@createCustomer')->name('createcustomer');
    Route::post('/{id}/update', 'Dealer\DealerController@update')->name('update');
    Route::get('/{dealer}/{start}/{end}/export', 'SuperAdmin\DashboardController@export')->name('customer.export');
    Route::post('/import_customer', 'Dealer\DealerController@import')->name('importcustomer');

});

app/Http/Controllers/SuperAdmin/AngpaoController.php
<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Entities\Bucket;
use App\Traits\Responder;
use Validator;

class AngpaoController extends Controller
{
    use Responder;

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data['buckets'] = Bucket::orderBy('nominal','DESC')->get();

        return view('superadmin.angpao.index',$data);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    public function addQty(Request $request,$id)
    {
        $validator = Validator::make($request->all(), [
          'qty' => 'required',
        ]);

        if ($validator->passes()) {
          $bucket = Bucket::find($id);
          $bucket->qty = $bucket->qty + $request->qty;

          if ($bucket->save()) {
            $response['redirect_url'] = route('superadmin.angpao.index');
            return $this->response(200, $response);
          }
        }else{
          $response['message'] = array_merge(['Data Invalid!'], $validator->errors()->all());
          return $this->response(400, $response);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/SuperAdmin/DashboardController.php
<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Entities\Bucket;
use App\Exports\CustomerExport;
use App\User;
use Carbon\Carbon;
use App\Entities\Customer;
use App\Entities\Configuration;
use Validator;
use App\Traits\Responder;

class DashboardController extends Controller
{
    use Responder;
  
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data['buckets'] = Bucket::all();
        $totalAngpao = 0;
        $totalAngpaoTerbuka = 0;
        $totalAngpaoTerpakai = 0;
        $jumlahAngpao = 0;
        $jumlahAngpaoTerpakai = 0;


        $jumlahhadiah = 0;
        $totalhadiahterbuka=0;
        // foreach ($data['buckets'] as $key => $value) {
        //   $totalAngpao = $totalAngpao + ($value->nominal * $value->qty);
        //   $totalAngpaoTerbuka = $totalAngpaoTerbuka + ($value->angpao->count() * $value->nominal);
        //   $totalAngpaoTerpakai = $totalAngpaoTerpakai + ($value->angpao->count() * $value->nominal);
        //   $jumlahAngpao = $jumlahAngpao + $value->qty;
        //   $jumlahAngpaoTerpakai = $jumlahAngpaoTerpakai + $value->angpao->count();
        // }

        foreach ($data['buckets'] as $key => $value) {
          $totalAngpao = $totalAngpao + ($value->qty);
          $totalAngpaoTerbuka = $totalAngpaoTerbuka + ($value->angpao->count());
          $totalAngpaoTerpakai = $totalAngpaoTerpakai + ($value->angpao->count());
          $jumlahAngpao = $jumlahAngpao + $value->qty;
          $jumlahAngpaoTerpakai = $jumlahAngpaoTerpakai + $value->angpao->count();
        }

        $data['totalangpao'] = $totalAngpao;
        $data['totalangpaoterbuka'] = $totalAngpaoTerbuka;
        $data['totalangpaotersisa'] = $totalAngpao - $totalAngpaoTerpakai;
        $data['jumlahangpaotersisa'] = $jumlahAngpao - $jumlahAngpaoTerpakai;
        $data['dealers'] = User::role('Dealer')->get();
        return view('superadmin.dashboard.index',$data);
    }

    public function export($dealer,$start,$end)
    {
      if ($dealer == "all") {
        $namaDelaer = "Semua Dealer";
      }else{
        $namaDelaer = "Dealer ".User::find($dealer)->name;
      }

      $carbonStart = Carbon::createFromFormat("m-d-Y",$start)->format('Y-m-d 00:00:00');
      $carbonEnd = Carbon::createFromFormat("m-d-Y",$end)->format('Y-m-d 00:00:00');

      return (new CustomerExport($dealer,$carbonStart,$carbonEnd))->download("Data Excel {$namaDelaer} Tanggal {$carbonStart} -  {$carbonEnd} Mitsubishi.xlsx");
    }

    
    public function setting()
    {
      $data['config'] = Configuration::findOrFail(1);
      return view('superadmin.setting.index',$data);
    }

    public function settingWebsite(Request $request)
    {
      $validator = Validator::make($request->all(), [
        'maintenance' => 'required',
      ]);

      if ($validator->passes()) {
        $config = Configuration::findOrFail(1);
        $config->maintenance = $request->maintenance;
        if ($config->save()) {
          $response['redirect_url'] = route('superadmin.setting');
          return $this->response(200, $response);
        }
      }else{
        $response['message'] = array_merge(['Data Invalid!'], $validator->errors()->all());
        return $this->response(400, $response);
      }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/SuperAdmin/DealerController.php
<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Imports\DealerImport;
use App\User;
use App\Traits\Responder;
use Maatwebsite\Excel\Facades\Excel;
use Validator;
use Hash;

class DealerController extends Controller
{
    use Responder;

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
      $data['dealers'] = User::role('Dealer')->get();
      return view('superadmin.dealer.index',$data);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
          'name' => 'required',
          'dealer_code' => 'required',
        ]);

        if ($validator->passes()) {
          $dealer =  new User();
          $dealer->name = $request->name;
          $dealer->dealer_code = $request->dealer_code;
          $password = $this->generate_unique_int(4);
          $check = User::where('password_real', $password)->count();

          while ($check != 0) {
              $password = generate_unique_int(4);
              $check = User::where('password_real', $password)->count();
          }

          $dealer->password = Hash::make($password);
          $dealer->password_real = $password;
          $dealer->city = $request->city;
          $dealer->provance = $request->provance;

          if ($dealer->save()) {
            $dealer->assignRole('Dealer');
            $response['redirect_url'] = route('superadmin.dealer.index');
            return $this->response(200, $response);
          }
        }else{
          $response['message'] = array_merge(['Data Invalid!'], $validator->errors()->all());
          return $this->response(400, $response);
        }
    }

    function generate_unique_int($lengthint =null)
    {
        $strstring = "angpao";

        $int = "123456789";
        $strint = substr(str_shuffle(str_repeat($int, 5)), 0, $lengthint);

        return $strstring.$strint;
    }

    public function dealerImport(Request $request)
    {
      $validator = Validator::make($request->all(), [
        'file' => 'required',
      ]);
      if ($validator->passes()) {
        // $import = (new DealerImport())->queue($request->file('file'));

        $import = Excel::import(new DealerImport(), $request->file('file'));
        if ($import) {
          $response['redirect_url'] = route('superadmin.dealer.index');
          return $this->response(200, $response);
        }
      }else{
        $response['message'] = array_merge(['Data Invalid!'], $validator->errors()->all());
        return $this->response(400, $response);
      }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $dealer = User::find($id);
        $data['dealer'] =$dealer;
        $totalAnpao = 0;
        foreach ($dealer->angpao as $key => $value) {
          $totalAnpao = $totalAnpao + $value->bucket->nominal;
        }

        $data['totalangpao'] = $totalAnpao;
        return $this->response(200, $data);

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
          'name' => 'required',
          'dealer_code' => 'required',
        ]);

        if ($validator->passes()) {
          $dealer = User::find($id);
          $dealer->name = $request->name;
          $dealer->dealer_code = $request->dealer_code;
          $dealer->city = $request->city;
          $dealer->provance = $request->provance;

          if ($dealer->save()) {
            $response['redirect_url'] = route('superadmin.dealer.index');
            return $this->response(200, $response);
          }
        }else{
          $response['message'] = array_merge(['Data Invalid!'], $validator->errors()->all());
          return $this->response(400, $response);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/superadmin/angpao/index.blade.php
@extends('superadmin.template')
@section('styles')
<style media="screen">
  .form-group{
    margin-bottom: 0px;
  }
  .fz-16{
    font-size: 16px;
  }
  .fstyle-title{
    color: #757575;
    font-size: 12px;
  }
  .disabled-input{
    background-color: #E8E8E8 !important;
    color: #2A2A2A !important;
  }
</style>
@endsection
@section('content')
<div class="content-wrapper">

  <!-- Page header -->
  <div class="page-header page-header-light">
    <div class="page-header-content header-elements-md-inline">
      <div class="page-title d-flex">
        <h4> <span class="font-weight-semibold">Kado</span></h4>
        <a href="#" class="header-elements-toggle text-default d-md-none"><i class="icon-more"></i></a>
      </div>
    </div>
  </div>
  <!-- /page header -->


  <!-- Content area -->
  <div class="content">

    <!-- Basic datatable -->
  				<div class="card">
  					<div class="card-header header-elements-inline">
  						<h5 class="card-title"><b>Daftar Kado</b></h5>
  					</div>

  					<table class="table table_dealer">
  						<thead>
  							<tr>
  								<th width="20%">Kado Tersedia</th>
  								<th width="20%">Jumlah Kado</th>
  								<th width="20%">Kado Terbuka</th>
  								<th width="20%">Kado Tersisa</th>
  								<th >Actions</th>
  							</tr>
  						</thead>
  						<tbody>
                <?php foreach ($buckets as $key => $bucket): ?>
                  <tr>
                    <td>{{$bucket->nominal}}</td>
                    <td>{{$bucket->qty}}</td>
                    <td>{{$bucket->angpao->count()}}</td>
                    <td>{{$bucket->qty - $bucket->angpao->count()}}</td>
                    <td>
                      <button type="button" class="btn btn-danger mr-2 modal-add" data-nominal="{{$bucket->nominal}}" data-id="{{$bucket->id}}">Tambah</button>
                      <a href="#"><button type="button" class="btn btn-light mr-2 modal-detail" data-nominal="{{$bucket->nominal}}" data-angpao="{{$bucket->qty}}" data-terbuka="{{$bucket->angpao->count()}}" data-tersisa="{{$bucket->qty - $bucket->angpao->count()}}" >Detail</button></a>
                    </td>
                  </tr>
                <?php endforeach; ?>
  						</tbody>
  					</table>
  				</div>
  				<!-- /basic datatable -->
          <div id="add_angpao" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title-account"><b>Tambah Kado</b></h5>
                  <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>

                <form class="kt-form" id="superuser-form" data-action="" enctype="multipart/form-data" autocomplete="off">
                  @csrf
                  <div class="modal-body">
                    <div class="form-group row">
                      <label class="col-form-label col-sm-3">Nama Kado</label>
                      <div class="col-sm-12">
                        <input type="text" class="form-control disabled-input" placeholder="Tulis Nominal Kado" value="{{$bucket->nominal}}" name="nominal" readonly disabled>
                      </div>
                    </div>

                    <div class="form-group row">
                      <label class="col-form-label col-sm-3">Tambahan Kado</label>
                      <div class="col-sm-12">
                        <input type="text" class="form-control" placeholder="Tulis tambahan kado" value="" name="qty">
                      </div>
                    </div>

                  </div>

                  <div class="modal-footer">
                    <button type="button" class="btn btn-light" data-dismiss="modal"><b>Kembali</b></button>
                    <button type="submit" name="submit" class="btn bg-danger"><b>Tambah</b></button>
                  </div>
                </form>
              </div>
            </div>
          </div>

          <div id="detail_dealer" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title-account"><b>Detail Kado</b></h5>
                  <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                  <div class="modal-body">
                    <div class="form-group row">
                      <label class="col-form-label col-sm-12 fstyle-title">Nama Kado</label>
                      <div class="col-sm-12">
                        <p class="fz-16"><b class="text-nominal">0</b></p>
                      </div>
                    </div>

                    <div class="form-group row">
                      <label class="col-form-label col-sm-12 fstyle-title">Jumlah Kado</label>
                      <div class="col-sm-12">
                        <p class="fz-16"><b class="text-angpao">0</b></p>
                      </div>
                    </div>

                    <div class="form-group row">
                      <label class="col-form-label col-sm-12 fstyle-title">Kado Terbuka</label>
                      <div class="col-sm-12">
                        <p class="fz-16"><b class="text-terbuka">0</b></p>
                      </div>
                    </div>

                    <div class="form-group row">
                      <label class="col-form-label col-sm-12 fstyle-title">Kado Tersisa</label>
                      <div class="col-sm-12">
                        <p class="fz-16"><b class="text-tersisa">0</b></p>
                      </div>
                    </div>

                  </div>

                  <div class="modal-footer">
                    <button type="button" class="btn btn-light" data-dismiss="modal"><b>Kembali</b></button>
                  </div>
              </div>
            </div>
          </div>
          
        </div>
  <!-- /content area -->
</div>
@endsection
@section('scripts')
<script src="{{asset('superuser_asset/global_assets/js/plugins/tables/datatables/datatables.min.js')}}"></script>
<script src="{{asset('superuser_asset/global_assets/js/demo_pages/datatables_basic.js')}}"></script>
<script src="{{asset('superuser_asset/form/form.js')}}"></script>
<script type="text/javascript">
$(document).ready(function() {
  $('.table_dealer').dataTable({
    "responsive": true,
    "processing": true,
    "filter":true,
    "order": [[1, 'desc']],
    "columnDefs": [{
        "orderable": false,
        "width": 100,
        "targets": [ 4 ]
    }],

  });
});

$(document).on('click','.modal-add',function(){
    var nominal = $(this).data('nominal');
    var id = $(this).data('id');
    $('[name="nominal"]').val(nominal);
    $('#add_angpao').modal('show');
    var urlAddQty = '{{ route("superadmin.angpao.addqty", ":id") }}';
    urlAddQty = urlAddQty.replace(':id', id);

    $('#superuser-form').attr('data-action', urlAddQty);

 });

 $(document).on('click','.modal-detail',function(){
     var nominal = $(this).data('nominal');
     var angpao = $(this).data('angpao');
     var terbuka = $(this).data('terbuka');
     var tersisa = $(this).data('tersisa');

     $('.text-nominal').text(nominal);
     $('.text-angpao').text(angpao);
     $('.text-terbuka').text(terbuka);
     $('.text-tersisa').text(tersisa);
     $('#detail_dealer').modal('show');
  });

</script>
@endsection